<?php
/*
Plugin Name: Quasar Form
Plugin URI: https://quasar-form.com
Description: Premium WordPress form and survey builder. Make amazing forms, incredibly fast.
Version: 3.2
Author: nucleus_genius
Text Domain: quasar-form
Domain Path: /lang/
*/

//URL
define( 'quasar_form_path', plugin_dir_path(__FILE__ ) );
define( 'quasar_form_url', plugins_url( '/', __FILE__ ) );
define( 'quasar_form_version', '3.2' );


// add button admin
add_action('admin_menu', 'quasar_form_main_addpanel' ); 
function quasar_form_main_addpanel() {
   add_menu_page('Quasar-form', 'Quasar Form', 'manage_options', 'quasar-form/admin.php', '', plugins_url( 'quasar-form/assets/img/icon2.png' ));
  
}


//add custom url
$quasar_form_url = quasar_form_path.'/quasar-form-main.php';


add_filter( 'plugin_action_links_'.plugin_basename(__FILE__), 'quasar_form_add_to_pro', 10, 4 );
function quasar_form_add_to_pro( $plugin_link, $quasar_form_url  ) {
    $plugin_link[] = '<a href="https://quasar-form.com/" style="color: red; font-weight: bold;" target="_blank">Go Pro!</a>';
	return $plugin_link;
}

//creating a database when activating the plugin
function quasar_form_addtable (){
	global $wpdb;
    $table_name = $wpdb->prefix . 'quasarform_main';
	$sql = "CREATE TABLE $table_name (
			id int(11) NOT NULL AUTO_INCREMENT,
			name mediumtext NOT NULL,
			content mediumtext NOT NULL,
			setting mediumtext NOT NULL,
			tabs mediumtext NOT NULL,
			logic mediumtext NOT NULL,
			date mediumtext NOT NULL,
			UNIQUE KEY id (id)
			);";
    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
    dbDelta( $sql );
    
    //table2
    $table_name = $wpdb->prefix . 'quasarform_history';
    $sql = "CREATE TABLE $table_name (
			id int(11) NOT NULL AUTO_INCREMENT,
			heading mediumtext NOT NULL,
			message mediumtext NOT NULL,
			data mediumtext NOT NULL,
			UNIQUE KEY id (id)
			);";
	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	dbDelta( $sql );
	
	//table3
	$table_name = $wpdb->prefix . 'quasarform_option';
    $sql = "CREATE TABLE $table_name (
			id int(11) NOT NULL AUTO_INCREMENT,
			mainparams mediumtext NOT NULL,
			UNIQUE KEY id (id)
			);";
	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	dbDelta( $sql );
    //default option
    $quasar_form_option = $wpdb->get_results( "SELECT * FROM {$wpdb->base_prefix}quasarform_option", ARRAY_A  );
    if ( count($quasar_form_option) == 0 ) {
        $wpdb->query( $wpdb->prepare( "INSERT INTO {$wpdb->base_prefix}quasarform_option ( `mainparams` ) VALUES ( %s )",  'not;not;not;not;not' ));
    }
	
	//we collect a database of site domains that use our plugin. No data other than the domain is sent
	$quasar_form_option = explode('/', get_site_url());
	$quasar_form_curl = curl_init();
    curl_setopt_array($quasar_form_curl, [
        CURLOPT_RETURNTRANSFER => 1,
        CURLOPT_URL => 'https://quasar-form.com/genevalidation2.php',
        CURLOPT_USERAGENT => 'Codular Sample cURL Request',
        CURLOPT_POST => 1,
        CURLOPT_POSTFIELDS => [
            'param2' => $quasar_form_option[2]
        ]
    ]);
    $quasar_form_otvet = curl_exec($quasar_form_curl);
    curl_close($quasar_form_curl);
}
register_activation_hook( __FILE__, 'quasar_form_addtable' );



function quasar_form_lang() {
	load_plugin_textdomain( 'quasar-form', false, dirname( plugin_basename( __FILE__ ) ) . '/lang/' ); 
}
add_action( 'plugins_loaded', 'quasar_form_lang' );


global $wpdb;
$quasar_form_option = $wpdb->get_results( "SELECT * FROM {$wpdb->base_prefix}quasarform_option WHERE id='1'", ARRAY_A  );
foreach($quasar_form_option as $row){
    if ( !preg_match("/;/", $row['mainparams']) ) {$array_option = 'not;not;not;not;not';}
    else { $array_option = explode(";",$row['mainparams']); }
}

//frontend
function quasar_form_frontend(){
    global $array_option;
        
    if ( $array_option[0] !='yes' ) { wp_enqueue_style('Quasar-form-icon', plugins_url( '/assets/font-awesome/css/font-awesome.css', __FILE__ ), array(), quasar_form_version); }
    wp_enqueue_style('Quasar-form-frontend-style', plugins_url( '/assets/css/frontend.css', __FILE__ ), array(), quasar_form_version );
    if ( $array_option[2] !='yes' ) { 
        wp_enqueue_script('jquery-ui-slider'); 
        wp_enqueue_script('touch-punch-frontend-script',plugins_url( '/lib/jquery-ui-touch-punch.min.js', __FILE__ ), array('jquery') , quasar_form_version, true);
    }
    if ( $array_option[1] !='yes' ) { 
        wp_enqueue_script('jquery-ui-datepicker'); 
        wp_localize_jquery_ui_datepicker(); 
    }
    
    //add frontend js
    wp_enqueue_script('Quasar-form-frontend-script',plugins_url( '/assets/js/frontend.js', __FILE__ ), array('jquery') , quasar_form_version, true);
    wp_localize_script('Quasar-form-frontend-script', 'params',
        array(
            'ajaxurlq' => admin_url('admin-ajax.php'),
            'nonce' => wp_create_nonce('nonce-frontend-q')
        )
    ); 
    
    //string-math
    if ( $array_option[4] !='yes' ) {
        wp_enqueue_script('string-math-q',plugins_url( '/lib/string-math.js', __FILE__ ), array('jquery') , quasar_form_version, true);
    }
    //mask
    if ( $array_option[3] !='yes' ) {
        wp_register_script('Quasar-form-maskedinput', plugins_url('/lib/maskedinput/maskedinput.js', __FILE__ ), array('jquery') , quasar_form_version, true );
        wp_enqueue_script('Quasar-form-maskedinput');
    }
}
add_action('wp_enqueue_scripts','quasar_form_frontend');




$quasar_form_array_popup = array(
    array(
        "id"  => "-",
    )
);
$quasar_form_array_logic_id = [];

//activation short code
function quasar_form_short_code($atts) {
    global $quasar_form_array_popup, $quasar_form_array_logic_id;

    
    $quasar_form_number = 0;
     
    // default params
    $quasar_form_array_form = shortcode_atts( array( 
      	'id' => '-', 
    	'type' => 'inline', 
    	'align' => 'center',
    	'text' => 'form'
    ), $atts ); 
    ob_start();
    
    //align
    $alignclass = $quasar_form_array_form['align'].'-align-q';

    //popup form
    if ( $quasar_form_array_form['type']=='popup' ){ 
        //array popup form
        $quasar_form_array_popup[] =array(
            "id"=> $quasar_form_array_form['id'],
            "type" => $quasar_form_array_form['type'],
            "align" => $quasar_form_array_form['align'],
            "text" => $quasar_form_array_form['text']
        );
        
        global $wpdb;
        $array_date_form = $wpdb->get_results( "SELECT * FROM {$wpdb->base_prefix}quasarform_main WHERE id = '".$quasar_form_array_form['id']."'" , ARRAY_A  );
        if ( count($array_date_form) > 0 ){
            //style popup button
            foreach($array_date_form as $row){
                $setting = explode("/",$row['setting']); 
            }
            $array_design = explode('|', $setting[3]);
        
            //class popup button  
            if ( $array_design[17] == ''){ $class = 'button-qform '.$alignclass.' '.$array_design[15].' '.$array_design[16].' button-unique-class-'.$quasar_form_number; }
            else { $class = 'button-qform '.$alignclass.' '.$array_design[15].' '.$array_design[16].' '.$array_design[17]. ' button-unique-class-'.$quasar_form_number; }

            echo '<div class="'.esc_attr( $class ).'" style="padding: '.esc_attr( $array_design[8] ).'; border-width: '.esc_attr( $array_design[9] ).'; background-color: '.esc_attr( $array_design[10] ).'; color: '.esc_attr( $array_design[11] ).'; font-size:'.esc_attr( $array_design[12] ).'; border-color: '.esc_attr( $array_design[13] ).'; border-radius: '.esc_attr( $array_design[14] ).'" data-form="'.esc_attr( $quasar_form_array_form['id'] ).'">'.esc_html( $quasar_form_array_form['text'] ).'</div>';
        }

    }
    //inline form
    if ($quasar_form_array_form['type']=='inline'){ 
        echo '<div class="inline-box-qform '.esc_attr( $alignclass ).'" >';
        include (quasar_form_path .'include/frontend-form.php');
        echo '</div>';
    }
    

    $output_string=ob_get_contents();
    ob_end_clean();
    return $output_string;
}
add_shortcode('formaQ', 'quasar_form_short_code');//activation short code function



//add popup form in footer
function quasar_form_popup_form(){
    global $quasar_form_array_popup;
    $array_id = [];
    foreach ( $quasar_form_array_popup as $key => $value ){
        if (count($value) == 4){
            $quasar_form_array_form =  array(
                "id"  => $value['id'],
                "type" => $value['type'],
                "align" => $value['align'],
                "text" => $value['text']
            );
            $array_id[] = $quasar_form_array_form['id'];
            $remove_dublicate = 0;
            foreach ( $array_id as $value2 ){
                if ($value2 == $quasar_form_array_form['id']){ $remove_dublicate++; }
            }
            if ($remove_dublicate <= 1 ){
                echo '<div class="modal-box-qform">';
                include (quasar_form_path.'include/frontend-form.php') ;
                echo '</div>';
            }
        }
    }
}
add_action( 'wp_footer', 'quasar_form_popup_form', 20 );



//admin
function quasar_form_admin_style() { 
    wp_enqueue_style('admin-styles-q2', plugins_url( '/assets/css/add-form.css', __FILE__ ), array(), quasar_form_version  );
}
add_action('admin_enqueue_scripts', 'quasar_form_admin_style');


//add script admin page 
function quasar_form_admin_script( $hook ){
    if( $hook != 'quasar-form/admin.php' ) return;
    
    //hide notifications
    remove_all_actions('admin_notices');
    
    //admin
    wp_register_script('Quasar-form-admin-script', plugins_url( '/assets/js/admin/admin.js', __FILE__ ), array(), quasar_form_version  );
    wp_enqueue_script('Quasar-form-admin-script');
    
    //drag and drop
    wp_register_script('Quasar-form-sortable', plugins_url( '/lib/Sortable-1.9.0.js', __FILE__ ) );
    wp_enqueue_script('Quasar-form-sortable');
    
    //mask
    wp_register_script('Quasar-form-maskedinput', plugins_url('/lib/maskedinput/maskedinput.js', __FILE__ ) );
    wp_enqueue_script('Quasar-form-maskedinput');
    
    //help
    wp_register_script('Quasar-form-help', plugins_url( '/assets/js/admin/admin-help.js', __FILE__ ),  array(), quasar_form_version  );
    wp_enqueue_script('Quasar-form-help');
    
    //admin quick-quasart js
    wp_register_script('Quasar-form-admin-quick-start', plugins_url( '/assets/js/admin/quick-start-form.js', __FILE__ ), array(), quasar_form_version  );
    wp_enqueue_script('Quasar-form-admin-quick-start');
    
    //admin ajax
    wp_localize_script('Quasar-form-admin-script', 'params',
        array(
            'ajaxurl' => admin_url('admin-ajax.php'),
            'put3' => plugins_url( '/', __FILE__ ),
            'nonce' => wp_create_nonce('q-ajax-nonce')
        )
    ); 
    
    
    //standart script
    wp_enqueue_script('jquery-ui-core');
    wp_enqueue_script('jquery-ui-widget');
    wp_enqueue_script('jquery-ui-button');
    wp_enqueue_script('jquery-ui-spinner');
    wp_enqueue_script('jquery-ui-slider');
    wp_enqueue_script('jquery-ui-sortable');
    wp_enqueue_script('jquery-ui-datepicker');
    wp_enqueue_script('jquery-color');
    wp_enqueue_style('wp-color-picker');
    wp_enqueue_script('wp-color-picker');
    wp_enqueue_script('iris');
    //wp editor
    wp_enqueue_editor();
    //admin fa fa
    wp_enqueue_style('Quasar-form-font-awesome', plugins_url( '/assets/font-awesome/css/font-awesome.min.css', __FILE__ ), array(), quasar_form_version  ); 
    //admin css
    wp_enqueue_style('Quasar-form-admin-style', plugins_url( '/assets/css/admin.css', __FILE__ ), array(), quasar_form_version );
    //admin alfa color picker
    wp_enqueue_style( 'Quasar-form-color-picker-alpha' );
    wp_enqueue_script( 'Quasar-form-color-picker-alpha',  plugins_url( '/lib/wp-color-picker-alpha-master/dist/wp-color-picker-alpha.min.js', __FILE__ ) , array( 'wp-color-picker' ) , quasar_form_version , true);
  
    //color localization
    wp_localize_script('Quasar-form-color-picker-alpha', 'localizationColor',
        array(
            'color' => esc_html__('Select Color','Quasar-form'),
            'clear' => esc_html__('Clear','Quasar-form'),
        )
    ); 
    
}
add_action('admin_enqueue_scripts','quasar_form_admin_script');


//add button "add form" in pages
function quasar_form_addform_button() {
    echo "<a id='add-form-q' class='button add-Quasar-form-classic'>".esc_html__('Add form','Quasar-form')."</a>";
}
add_action('media_buttons', 'quasar_form_addform_button', 15);



//add button and add cutom block in editor js
function quasar_form_addform_button_script() {
    //classic
    wp_enqueue_script('Quasar-form-classic',plugins_url( '/assets/js/admin/add-form-classic.js', __FILE__ ), array('jquery'), quasar_form_version );
    //block
    wp_enqueue_script('Quasar-form-block', plugins_url( '/assets/js/admin/add-form-gutenberg.js', __FILE__ ), array( 'wp-blocks', 'wp-i18n', 'wp-element', 'wp-components' ), quasar_form_version );
    //block localization
    wp_localize_script('Quasar-form-block', 'localization3',
        array(
            'left' =>  esc_html__('Left','Quasar-form'),
            'right' => esc_html__('Right','Quasar-form'),
            'center' => esc_html__('Center','Quasar-form'),
            'inline' => esc_html__('Inline','Quasar-form'),
            'popup' => esc_html__('Popup','Quasar-form'),
            'buttontext' => esc_html__('Button text','Quasar-form'),
            'selectform' => esc_html__('Select form','Quasar-form'),
            'alignform' => esc_html__('Align of form','Quasar-form'),
            'typeform' => esc_html__('Type of form','Quasar-form'),
            'selectformname' => esc_html__('Form name','Quasar-form'),
            'ajaxurl' => admin_url('admin-ajax.php'),
            'nonce' => wp_create_nonce('q-ajax-nonce')
        )
    ); 
} 
add_action('admin_enqueue_scripts', 'quasar_form_addform_button_script');

//add button html popup
add_action (  'admin_footer' , 'quasar_form_popup_buttton_html' ) ; 
function  quasar_form_popup_buttton_html( ) { 
    global $wpdb;
    $array_form = $wpdb->get_results( "SELECT * FROM {$wpdb->prefix}quasarform_main" , ARRAY_A  );
    $number = 0 ; 
    $str_add_form = '';
    foreach($array_form as $row){ // list name form
        //name
        if ( json_decode($row['name']) != null ){ 
            $row['name'] = str_replace( 'RTQasB',  '\\',  $row['name'] );
	        $row['name'] = json_decode( $row['name'] );
        }
	    
        if ($number == 0){ 
            $str_add_form.='<input id="form'.esc_html( $row['id'] ).'" type="radio" name="nameform" data-id="'.esc_html( $row['id'] ).'" checked></input> <label for="form'.esc_html( $row['id'] ).'"> <div class="checkbox-qform"><div class="checkbox-fafa"></div></div> <span>'.esc_html( $row['name'] ).'</span></label>';
        }
        else { 
            $str_add_form.= '<input id="form'.esc_html( $row['id'] ).'" type="radio" name="nameform" data-id="'.esc_html( $row['id'] ).'"></input> <label for="form'.esc_html( $row['id'] ).'"> <div class="checkbox-qform"><div class="checkbox-fafa"></div></div> <span>'.esc_html( $row['name'] ).'</span></label>'; 
        }
        $number++; 
    }
    
    if (get_bloginfo('language')== 'ru-RU'){
        $text_1 = 'Выберите форму';
        $text_2 = 'Тип формы';
        $text_3 = 'Инлайн форма';
        $text_4 = 'Всплывающая форма';
        $text_5 = 'Выравнивание';
        $text_6 = 'По центру';
        $text_7 = 'По правому краю';
        $text_8 = 'По левому краю';
        $text_9 = 'Текст кнопки';
        $text_10 = 'Добавить форму';
        $text_11 = 'Пожалуйста, сообщите нам причину деактивации плагина.';
        $text_12 = 'Выбрать';
        $text_13 = 'Отправить сообщение';
        $text_14 = 'Пропустить';
        $text_15 = 'Если у вас возникли проблемы с плагином, пожалуйста, опишите их. В следующем обновлении мы внесем исправления';
        $text_16 = 'Ваш комментарий';
        $text_17 = 'Деактивация';
    }
    else {
        $text_1 = 'Select form';
        $text_2 = 'Type of form';
        $text_3 = 'Inline form';
        $text_4 = 'Popup form';
        $text_5 = 'Align';
        $text_6 = 'Center';
        $text_7 = 'Right';
        $text_8 = 'Left';
        $text_9 = 'Button text';
        $text_10 = 'Add form';
        $text_11 = 'Please let us know the reason for deactivating the plugin.';
        $text_12 = 'Select';
        $text_13 = 'Send a message';
        $text_14 = 'Skip';
        $text_15 = 'If you have problems, please describe them. In the next update we will make fixes';
        $text_16 = 'Your comment';
        $text_17 = 'Deactivate';
    }
    
    echo '
    <div class="swap-modal-add-form"> 
        <div class="modal-add-form"> 
            <div class="heading-quasar-add-form">Quasar-form</div>
        
            <div class="swap-selected-block">
                <div class="modal-heading-q">'.esc_html($text_1).'</div>
                <div id="select_name_form" class="type-checkbox-element radio-select"> 
                    '.wp_specialchars_decode( $str_add_form ).'
                </div>
            </div>
            
            <div class="swap-selected-block">
                <div class="modal-heading-q">'.esc_html($text_2).'</div> 
                <div id="select_type_form" class="type-checkbox-element radio-select">
                    <input id="form-tip-inline" type="radio" name="tip" data-type="inline" checked></input>
                    <label for="form-tip-inline"> 
                        <div class="checkbox-qform">
                            <div class="checkbox-fafa"></div>
                        </div> 
                        <span>'.esc_html($text_3).'</span>
                    </label>
                    <input id="form-tip-popup" type="radio" name="tip" data-type="popup"></input> 
                    <label for="form-tip-popup"> 
                        <div class="checkbox-qform">
                            <div class="checkbox-fafa"></div>
                        </div> 
                        <span>'.esc_html($text_4).'</span>
                    </label>
                </div>
            </div> 
            
            <div class="swap-selected-block align-setting-q">
                <div class="modal-heading-q">'.esc_html($text_5).'</div>
                <div id="select_align_form" class="type-checkbox-element radio-select">
                    <input id="form-center-align" name="align" type="radio" data-align="center" checked></input> 
                    <label for="form-center-align">
                        <div class="checkbox-qform">
                            <div class="checkbox-fafa"></div>
                        </div> 
                        <span>'.esc_html($text_6).'</span>
                    </label>
                    <input id="form-center-right" name="align" type="radio" data-align="right"></input> 
                    <label for="form-center-right">
                        <div class="checkbox-qform"> 
                            <div class="checkbox-fafa"></div>
                        </div> 
                        <span>'.esc_html($text_7).'</span>
                    </label>
                    <input id="form-center-left" name="align" type="radio" data-align="left"></input> 
                    <label for="form-center-left">
                        <div class="checkbox-qform">
                            <div class="checkbox-fafa"></div>
                        </div> 
                        <span>'.esc_html($text_8).'</span>
                    </label>
                </div>
            </div>
            
            <div class="swap-selected-block text-popup-q"> 
                <div class="modal-heading-q">'.esc_html($text_9).'</div> 
                <input id="text-button-q">
            </div>
            
            <div class="swap-selected-block save-element-adm-form">
                <div class="button-add-form">'.esc_html($text_10).'</div>
            </div>
        </div>
    </div>

     <div class="swap-modal-add-form-deactivate"> 
        <div class="modal-add-form-deactivate"> 
            <div class="heading-quasar-add-form">Quasar Form</div>
        
            <div class="swap-selected-block">
                <div class="text-deactivate-1">'.esc_html($text_11).'</div>
            </div>
            
            <div class="swap-selected-block">
                <div class="modal-heading-q">'.esc_html__($text_12).'</div> 
                <div id="select_deactivation-quasar-form" class="type-checkbox-element radio-select">
                    <input id="quasar-form-dectivate-message" type="radio" name="deactivate-quasar" data-type="inline" checked></input>
                    <label for="quasar-form-dectivate-message"> 
                        <div class="checkbox-qform">
                            <div class="checkbox-fafa"></div>
                        </div> 
                        <span>'.esc_html($text_13).'</span>
                    </label>
                    <input id="quasar-form-dectivate-not" type="radio" name="deactivate-quasar" data-type="popup"></input> 
                    <label for="quasar-form-dectivate-not"> 
                        <div class="checkbox-qform">
                            <div class="checkbox-fafa"></div>
                        </div> 
                        <span>'.esc_html($text_14).'</span>
                    </label>
                </div>
            </div> 
            
            <div class="swap-selected-block align-setting-q">
                <div class="text-deactivate-2">'.esc_html($text_15).'</div>
                <textarea class="message-deacticate-quasar-form requed-message-q" placeholder="'.esc_html($text_16).'"></textarea>
                
            </div>
            
            
            <div class="swap-selected-block save-element-adm-form">
                <div class="button-deactivate-quasar-form">'.esc_html($text_17).'</div>
            </div>
        </div>
    </div>';
}




//functions
add_action('wp_ajax_mail_send_q', 'quasar_form_sendmail' ); 
add_action('wp_ajax_save_forma_q', 'quasar_form_save' ); 
add_action('wp_ajax_nopriv_mail_send_q', 'quasar_form_sendmail'); 
add_action('wp_ajax_remove_form', 'quasar_form_removeform'); 
add_action('wp_ajax_deactivate_q', 'quasar_form_deactivate');
add_action('wp_ajax_remove_history_message', 'quasar_form_remove_message'); 
add_action('wp_ajax_save_active_lib_q', 'quasar_form_pro_option' ); 

//option 
function quasar_form_pro_option(){
    
    // Check nonce 
    check_ajax_referer( 'q-ajax-nonce', 'nonce_code' );
    
    // Stop if the current user is not an admin or do not have administrative access
	if( ! current_user_can( 'manage_options' ) ) {
		die();
	}
    
    $option = sanitize_text_field( $_POST['option'] );
    global $wpdb;
    $wpdb->query( $wpdb->prepare(  "UPDATE {$wpdb->base_prefix}quasarform_option SET mainparams = '$option' WHERE ID = '1'", '%s' , '%d'  ));
}

// save/update form
function quasar_form_save(){
    
	// Check nonce 
    check_ajax_referer( 'q-ajax-nonce', 'nonce_code' );
    
    // Stop if the current user is not an admin or do not have administrative access
	if( ! current_user_can( 'manage_options' ) ) {
		die();
	}
    	
    $quasar_form_save_array = array(
        'content' => sanitize_text_field( $_POST['inbd'] ),
        'setting' => sanitize_text_field( $_POST['settingsbd'] ),
        'tabs' => sanitize_text_field ( $_POST['tabsq'] ),
        'logic' => sanitize_text_field ( $_POST['logic'] )
    );
    $name_form_prev_last = explode("/", sanitize_text_field($_POST['nameformq']) ); //prev and last name form


    global $wpdb;
    $update_check = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}quasarform_main ", ARRAY_A  );
    $number = 0;
    $mumber_decode = 0;
    foreach( $update_check as $row){
        $mumber_decode = 0;
        //name
        if ( json_decode($row['name']) != null ){ 
            $row['name'] = str_replace( 'RTQasB',  '\\',  $row['name'] );
            $row['name'] = json_decode($row['name']);
            $mumber_decode++;
        }
        
        if ( $row['name'] == $name_form_prev_last[0] ) { 
            $number++; 
            //back coding in json
            if ( $mumber_decode > 0 ){
                $row['name'] = wp_json_encode( $row['name'] );
                $row['name'] = str_replace( '\\', 'RTQasB', $row['name'] );
                $name_form_prev_last[0] = $row['name'];
            }
        }
    }
    $update_check = $number;

    $date = date("Y-m-d-G"); //date 

    //name new
    $name_form_prev_last[1] = wp_json_encode( $name_form_prev_last[1] );
    $name_form_prev_last[1] = str_replace( '\\', 'RTQasB', $name_form_prev_last[1] );
    
    //content
    $quasar_form_save_array['content'] = explode( '/', $quasar_form_save_array['content'] );
    $quasar_form_save_array['content'] = wp_json_encode( $quasar_form_save_array['content'] );
    $quasar_form_save_array['content'] = str_replace( '\\', 'RTQasB', $quasar_form_save_array['content'] );

    //setting
    $quasar_form_save_array['setting'] = wp_json_encode( $quasar_form_save_array['setting'] );
    $quasar_form_save_array['setting'] = str_replace( '\\', 'RTQasB', $quasar_form_save_array['setting'] );

    
    
    //creating a new form
    if ($update_check==0){
        $wpdb->query( $wpdb->prepare( "INSERT INTO {$wpdb->prefix}quasarform_main ( `name`, `content`, `setting`,`tabs` , `logic` , `date`) VALUES ( %s, %s, %s, %s, %s, %s)", $name_form_prev_last[1], $quasar_form_save_array['content'] , $quasar_form_save_array['setting'] , $quasar_form_save_array['tabs'] , $quasar_form_save_array['logic'] , $date , $date.$name_form_prev_last[0] ));
    }
    //updating the current form
    else { 
        $wpdb->query( $wpdb->prepare("UPDATE {$wpdb->prefix}quasarform_main SET `name` = '".$name_form_prev_last[1]."', `content` = '".$quasar_form_save_array['content']."' , `setting` = '".$quasar_form_save_array['setting']."' , `tabs` = '".$quasar_form_save_array['tabs']."' , `logic` = '".$quasar_form_save_array['logic']."', `date` = '".$date."'  WHERE name  = '".$name_form_prev_last[0]."' ",  '%s' , '%s', '%s', '%s', '%s' ));
    }
    wp_die();
}

//Send mail
function quasar_form_sendmail(){ 
   	
  // Check nonce 
  check_ajax_referer( 'nonce-frontend-q', 'nonce_code' );
    
  function quasar_form_send_mail( $to, $body, $email, $filepath, $filename ) {
    $quasar_form_idform = sanitize_text_field( $_POST['id-form'] ); //id this form
    //information on this form from the database
    global $wpdb;
    $quasar_form_array_this_form = $wpdb->get_results("SELECT * FROM {$wpdb->base_prefix}quasarform_main  WHERE id ='$quasar_form_idform' ", ARRAY_A );
    foreach($quasar_form_array_this_form as $row){
         
        if ( json_decode( $row['setting'] ) != null ){ 
            $row['setting'] = str_replace( 'RTQasB',  '\\',  $row['setting'] );
            $row['setting'] = json_decode($row['setting']);
        }
        $setting = explode('/',  $row['setting'] );
              
        if ( json_decode( $row['name'] ) != null ){ 
            $row['name'] = str_replace( 'RTQasB',  '\\',  $row['name'] );
            $row['name'] = json_decode($row['name']);
        }
        
        if ( json_decode( $row['content'] ) != null ){ 
            $row['content'] = str_replace( 'RTQasB',  '\\',  $row['content'] );
            $row['content'] = json_decode($row['content']);
            $all_field_string =  $row['content'];
        }
        else  {
            $all_field_string = maybe_unserialize( $row['content'] );
        }
        
        $name_form_history = $row['name'];
    }
    //search field upload buttons
    $string_valid_file_extensions = '';
    foreach( $all_field_string as $val ){
        $array_field = explode(";", $val );
        if ($array_field['0'] == 'type-upload-element') {
            //str of valid file extensions
            $string_valid_file_extensions.= $array_field['8'].',';
        }
        
    }
    
    $form_array_mail = explode('|', $setting[2]);
  
    //parse the line with the contents of all form fields + html custom ;
    $str_content_mail ='';
    $array_value_field =[];
    $array_content_mail = explode('RazDelITEL', sanitize_text_field ($_POST['contentQform']) );
    $array_content_mail = array_filter($array_content_mail) ;//delete empty values
    foreach($array_content_mail as $key => $value){
        $array_value_field  = explode(';', $value );
        $array_value_field = array_filter( $array_value_field);
        $array_count = count($array_value_field) - 1;
        $number_1 = 0; 
        $number_2 = 1;
        $stringcontent = '';
        if ( $array_count > 2){$checkbox = 'yes';}
        else { $checkbox = 'no'; }
        //value this field
        while($array_count >0){
            $number_1++;
            //all field
            if ($checkbox != 'yes'){
                if ( $array_value_field[1] !='' && $array_value_field[2] != '' ){ $stringcontent = '<b>'.$array_value_field[1].'</b>: '; }
                $stringcontent.= $array_value_field[2].'<br>';
            }
            //checkbox
            if ($checkbox == 'yes'){
                if ($number_1 == 1){
                    $stringcontent.='<b>'.$array_value_field[$number_2].'</b><br>';
                }
                if ($number_1 > 1){
                    $stringcontent.=$array_value_field[$number_2].'<br>';
                }  
            }
            $number_2++;
            $array_count--;
        }
        $str_content_mail.= $stringcontent;
        $array_value_field[$array_value_field[0]]= $stringcontent;
    }
   
    $urlpage = sanitize_text_field( $_POST['urlpage'] );
    $headingpage = sanitize_text_field( $_POST['titlepage'] );
    
    //recovery of special characters
    $messag_email = str_replace( "@TRDEEEQWGG", "/", $form_array_mail[2] ); 
    $messag_email = str_replace( "SkobKi", "<", $messag_email );
    $messag_email = str_replace( "SKrjlfd", ">", $messag_email ); 
    $messag_email = str_replace( "%1%", "<", $messag_email );
    $messag_email = str_replace( "@2F", ">", $messag_email ); 
    $messag_email = str_replace( "&1&", "'", $messag_email ); 
    $messag_email = str_replace( "&2&", '"', $messag_email ); 
    $messag_email = str_replace( "KLFD2NFD", '"', $messag_email ); 
    $messag_email = str_replace( "GndRERD", "'", $messag_email );
    $messag_email = str_replace( "@P$", "|", $messag_email );
    $messag_email = str_replace( "gt;", ">", $messag_email );
    $messag_email = str_replace( "lt;", "<", $messag_email );
    $messag_email = str_replace( "<#p>", "</p>", $messag_email );
   
    preg_match_all('/\[.*?\]/' , $messag_email , $array_short_code); //search  [ ... ]

    //array of replacing short codes with values
    foreach ( $array_short_code as $key => $value){
        foreach ( $value as $key2 => $value2){
            //replace short code custom field id
            if ($value2 !='[content form]' && $value2 !='[URL]' && $value2 !='[Time]' ){
                $fieldidq = $value2;
                $fieldidq = substr($fieldidq, 1, -1);
                $fieldidq = strip_tags($fieldidq);
                if (array_key_exists($fieldidq, $array_value_field)) {//if this key is present in the array of all fields
                    $messag_email = str_replace( $value2,  $array_value_field[$fieldidq], $messag_email );
                }
            } 
            //replace short code: [content form] , [URL] , [Time]
            if ($value2=='[content form]'){ $messag_email = str_replace( $value2,  $str_content_mail , $messag_email );  }
            if ($value2=='[URL]'){ $messag_email = str_replace( $value2,  $urlpage , $messag_email );  }
            if ($value2=='[page title]'){ $messag_email = str_replace( $value2,  $headingpage , $messag_email );  }
            if ($value2=='[Time]'){ $messag_email = str_replace( $value2,  current_time( 'H:i:s Y-m-d'  ) , $messag_email ); }
        }
    }


    //save message in database
    global $wpdb;
    
    $messag_email_in_db = wp_json_encode( $messag_email );
    $messag_email_in_db = str_replace( '\\', 'RTQasB', $messag_email_in_db );
    
    if ( json_encode( $name_form_history) != true ){ 
        $name_form_history = wp_json_encode( $name_form_history );
        $name_form_history = str_replace( '\\', 'RTQasB', $name_form_history );
    }
    
    $name_form_history = sanitize_text_field($name_form_history);
    $wpdb->query( $wpdb->prepare( "INSERT INTO {$wpdb->base_prefix}quasarform_history ( `message`, `heading`, `data`) VALUES ( %s, %s, %s )", $messag_email, $name_form_history, current_time( 'H:i Y-m-d'  )  ));
  
    $array_history = $wpdb->get_results("SELECT * FROM {$wpdb->base_prefix}quasarform_history" ,  ARRAY_A );
    if (count($array_history) > 30){;
        //delete row with lowest id
        $array_id = [];
        foreach ($array_history as $row){
            $array_id[] = $row['id'];
        }
        $wpdb->query("DELETE FROM {$wpdb->base_prefix}quasarform_history WHERE id = '".$array_id[0]."' ");
      
    }
    //letter heading - reading short code [Form Name]
    preg_match_all('/\[.*?\]/' , $form_array_mail[1] , $array_skobki_name);
    foreach ( $array_skobki_name as $key => $value){
        foreach ( $value as $key2 => $value2){
            if ($value2=='[Form Name]'){  
               $form_array_mail[1] = str_replace( $value2,  $name_form_history , $form_array_mail[1] );
            }
        }
    }
    
    
     
    //method SMTP
    if ($form_array_mail[3]=='mailsmtp'){ 
        
        require (quasar_form_path.'lib/PHPMailer/PHPMailer.php'); 
        require (quasar_form_path.'lib/PHPMailer/SMTP.php');
        
        $mail = new PHPMailer\PHPMailer\PHPMailer();
        try {
            $msg = "ok";
            $mail->isSMTP();   
            $mail->CharSet = "UTF-8";                                          
            $mail->SMTPAuth   = true;
            //mail password decoding
            
            $form_array_mail[9] = str_replace( "@TRDEEEQWGG", "/",  $form_array_mail[9] );
            $form_array_mail[9] = str_replace( "@RRRRDDDETGCDSW", "\\",  $form_array_mail[9] );
            $form_array_mail[9] = str_replace( "@PQWRTEADYY", "|",  $form_array_mail[9] );
            $form_array_mail[9] = str_replace( "@RRDDYESQWQOOJ", "<",  $form_array_mail[9] );
            $form_array_mail[9] = str_replace( "@ARWSFGGGGCDCSARYHB", ">",  $form_array_mail[9] );
            $form_array_mail[9] = str_replace( "@YTREWASCGNBFDSI", "'",  $form_array_mail[9] );
            $form_array_mail[9] = str_replace( "@GFDRHGFYHKJHG", '"',  $form_array_mail[9] );
            $form_array_mail[9] = str_replace( "@RRTTESVCGHNFDEWSHM", '&',  $form_array_mail[9] );

            
            // setting
            $mail->Host       = $form_array_mail[10]; // SMTP 
            $mail->Username   = $form_array_mail[8]; // login
            $mail->Password   = $form_array_mail[9]; // password
            $mail->SMTPSecure = 'ssl'; // ssl
            $mail->Port       = $form_array_mail[11];//port
            $mail->setFrom($form_array_mail[7], $form_array_mail[6]); // email and name 
            //address of the recipient
            //many mails
            if (preg_match("/,/", $form_array_mail[0])) {
                $massivmail = explode(',' , $form_array_mail[0]);
                foreach($massivmail as $key => $value){
                    $mail->addAddress($value); 
               }
            }
            //one mail
            else { 
                $mail->addAddress($form_array_mail[0]);
            }
            $str = '';
            // send file
            if (!empty($_FILES['file']['name'][0])) {
                for ($ct = 0; $ct < count($_FILES['file']['tmp_name']); $ct++) {
                    $uploadfile = tempnam(sys_get_temp_dir(), sha1($_FILES['myfile']['name'][$ct]));
                    $filename = $_FILES['file']['name'][$ct];

                    //weed out files with an invalid extension for phpmailer
                    $file_type = explode('.', $filename); 
                    $file_type = array_pop($file_type);//type this fail
                    $array_valid_file_extensions = explode(',' , $string_valid_file_extensions);
                    $valid = 0;
                    foreach  ( $array_valid_file_extensions as $value){
                        if ( $value == $file_type ) { 
                            $valid++; 
                            $str.=' 2 -'.$value; 
                        }
                    }
                    // validation file
                    if ( $valid > 0 ){
                        $str.=' 1 ';
                        if (move_uploaded_file($_FILES['file']['tmp_name'][$ct], $uploadfile)) {
                            $mail->addAttachment($uploadfile, $filename);
                        } 
                        else { $msg .= esc_html__('Could not attach file','quasar-form-pro') . $uploadfile; }
                    }
               }   
            }
            // message
            $mail->isHTML(true);
            $mail->Subject = $form_array_mail[1];//heading message
            $mail->Body    = $messag_email; //message
            
             
            // sending status
            if ($mail->send()) { echo esc_html( $msg ); }
            else { echo esc_html__('Message was not sent. Your email settings are incorrect','quasar-form-pro'); }
       } 
       catch (Exception $e) { echo esc_html__('Message was not sent. Cause of error','quasar-form-pro').": {$mail->ErrorInfo}"; }
    }
    
    //method wp mail
    else {
        //address of the recipient
        //many mails
        if (preg_match("/,/", $form_array_mail[0])) {
            $massivmail = explode(',' , $form_array_mail[0]);
            $to = $massivmail;
        }
        //one mail
        else { 
            $to = $form_array_mail[0];
        }
        $to = $form_array_mail[0];//email
        $subject = $form_array_mail[1]; //subject
        $headers = "Content-type: text/html; charset=UTF-8 \r\n";
        $headers .= 'From: '.$form_array_mail[4].' <'.$form_array_mail[5].'>' . "\r\n"; 
        $headers .= "MIME-Version: 1.0\r\n";
        //content message
        $body = '<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /></head><body>'; 
        $body .= $messag_email;
        $body .= '</body></html>';
        $body = $body."\r\n\r\n";
        $multipart = $body;
        $file = [];
        $q = 0;
        if (0 <count($_FILES) ) {
	        if ( ! function_exists( 'wp_handle_upload' ) ) { require_once( ABSPATH . 'wp-admin/includes/file.php' ); }
	        $uploadedfile = $_FILES['file'];
	        $chislo = count($_FILES['file']);
	        foreach($uploadedfile['name'] as $key => $value ){ 
	            if ($uploadedfile['name'][$key]) {
                    $file2 = array(
                        'name'     => sanitize_file_name( $uploadedfile['name'][$key] ),
                        'type'     => esc_html( $uploadedfile['type'][$key] ),
                        'tmp_name' => esc_html( $uploadedfile['tmp_name'][$key] ),
                        'error'    => esc_html( $uploadedfile['error'][$key] ),
                        'size'     => $uploadedfile['size'][$key]
                    );
                    
                    //weed out files with an invalid extension for wp mail
                    $file_type = explode('.', $file2['name']); 
                    $file_type = array_pop($file_type);//type this fail
                    $array_valid_file_extensions = explode(',' , $string_valid_file_extensions);
                    $valid = 0;
                    foreach  ( $array_valid_file_extensions as $value){
                        if ( $value == $file_type ) { $valid++; }
                    }
                    // validation file
                    if ( $valid > 0 ){
                        //file upload
	                    $overrides = [ 'test_form' => false ];
                        $movefile = wp_handle_upload($file2,$overrides);
	                    $file[] = $movefile['file'];
                    }
	           }
           }
        }
        
        wp_mail($to, $subject, $multipart ,  $headers, $file);
 
   }
 } //end function quasar_form_send_mail
 
 //variables file
 $file = [];
 $filepath = '';
 $filename = '';

 //launch send function
 $to='';  
 $body=''; 
 $email= '';
 $quasar_form_idform ='';
 quasar_form_send_mail($to, $body, $email, $filepath ,$quasar_form_idform  );
}

//remove form
function quasar_form_removeform(){
	// Check nonce 
    check_ajax_referer( 'q-ajax-nonce', 'nonce_code' ); 
    
    // Stop if the current user is not an admin or do not have administrative access
	if( ! current_user_can( 'manage_options' ) ) {
		die();
	}
    
    $removefunction = sanitize_text_field($_POST['removeform']);
    global $wpdb;
    $wpdb->query("DELETE FROM {$wpdb->prefix}quasarform_main WHERE id = '".$removefunction."' ");
    
    wp_die();
}


//remove message in history
function quasar_form_remove_message(){

	// Check nonce 
    check_ajax_referer( 'q-ajax-nonce', 'nonce_code' );
    
    // Stop if the current user is not an admin or do not have administrative access
	if( ! current_user_can( 'manage_options' ) ) {
		die();
	}
	
    $removefunction = sanitize_text_field($_POST['removemessage']);
    global $wpdb;
    $wpdb->query("DELETE FROM {$wpdb->prefix}quasarform_history WHERE id = '".$removefunction."' ");
    
    wp_die();
}


//deactivate
function quasar_form_deactivate(){
    // Check nonce 
    check_ajax_referer( 'q-ajax-nonce', 'nonce_code' ); 
    
    // Stop if the current user is not an admin or do not have administrative access
	if( ! current_user_can( 'manage_options' ) ) {
		die();
	}
	//sending messages to the server, which you can leave when you disable the plugin
	$message = sanitize_text_field($_POST['messagedeactivate']);
	$quasar_form_curl = curl_init();
    curl_setopt_array($quasar_form_curl, [
        CURLOPT_RETURNTRANSFER => 1,
        CURLOPT_URL => 'https://quasar-form.com/genevalidation3.php',
        CURLOPT_USERAGENT => 'Codular Sample cURL Request',
        CURLOPT_POST => 1,
        CURLOPT_POSTFIELDS => [
            'message' => $message
        ]
    ]);
    $quasar_form_otvet = curl_exec($quasar_form_curl);
    curl_close($quasar_form_curl);
};